package apt.plan2d;

import java.awt.*;

/**
 *
 * Places a "satellite" rectangle near the edge of
 * a "nucleus" rectangle.
 *
 * This code is currently used only in
 * the RandomFloorPlan class.
 *
 */
class RectangleAdjoiner
{
    static Point temp=new Point(0,0);

    public void adjoin(Rectangle nucleus, Rectangle satellite,
                       double placement, double depth)
    {
       int x1=(int)(nucleus.x+depth*nucleus.width)-satellite.width;
       int y1=(int)(nucleus.y+depth*nucleus.height)-satellite.height;
       int x2=(int)(nucleus.x+(1-depth)*nucleus.width);
       int y2=(int)(nucleus.y+(1-depth)*nucleus.height);
       perimeterPoint(x1,y1,x2,y2, placement, temp);
       satellite.x=temp.x;
       satellite.y=temp.y;
    }

    // 0<=t<=1
    public void perimeterPoint(int x1, int y1, int x2, int y2,
                               double t, Point p)
    {
        int w=x2-x1; int h=y2-y1;
        t*=2*(w+h);

        if (t<w)
        {
            p.y=y1;
            p.x=(int)(x1+t);
            return;
        }
        t-=w;

        if (t<h)
        {
            p.x=x2;
            p.y=(int)(y1+t);
            return;
        }
        t-=h;

        if (t<w)
        {
            p.y=y2;
            p.x=(int)(x1+t);
            return;
        }
        t-=w;

        p.x=x1;
        p.y=(int)(y1+t);
    }


    public double overlap(Rectangle r1, Rectangle r2)
    {
        int area1=r1.width*r1.height;
        return intersectionArea(r1,r2)/area1;
    }

    public double intersectionArea(Rectangle r1, Rectangle r2)
    {
        if (!r1.intersects(r2))
            return 0;
    	int x1 = Math.max(r1.x, r2.x);
    	int x2 = Math.min(r1.x + r1.width, r2.x + r2.width);
    	int y1 = Math.max(r1.y, r2.y);
    	int y2 = Math.min(r1.y + r1.height, r2.y + r2.height);
    	return (x2 - x1)*(y2 - y1);
    }

}