package apt.plan2d;

import java.util.*;
import java.awt.*;

/**
 *
 * A Room represents a room in the apartment.
 *
 */
public class Room
{
    public double size;
    public Color color;
    public int wallWidth=1;
    public double x,y,w,h;
    
    private Room parent;
    private Vector children=new Vector();
    private String name;
    
    public void setName(String name)
    {
        this.name=name;
    }
   
    
    public Room getParent()
    {
        return parent;
    }
    
    public int childCount()
    {
        return children.size();
    }
    
    public Room getChild(int i)
    {
        return (Room)children.elementAt(i);
    }
    
    public void addChild(Room r)
    {
        children.addElement(r);
    }
    
    public String getName()
    {
        return name;
    }
    
    public void addTraversal(Vector v)
    {
        //System.out.println("at: "+this);
        v.addElement(this);
        int n=childCount();
        if (n>0)
        {
            for (int i=0; i<n; i++)
            {
                getChild(i).addTraversal(v);
                v.addElement(this);
            }
        }
    }
    
    public void clearChildren()
    {
        children=new Vector();
    }
  

    public Room()
    {
        this(.1);
    }

    public Room(double size)
    {
        this.size=size;
    }
    
    public double getSize()
    {
        return size;
    }

    public void setRect(double x, double y, double w, double h)
    {
        this.x=x; this.y=y; this.w=w; this.h=h;
    }

    public String toString()
    {
        //return "[Room, size="+size+"]";
        return name;//"["+name+"]";
    }

}

