package apt.plan3d;

import java.applet.*;
import java.awt.*;
import java.util.*;
import space.*;

/**
 * 
 * This class, which exists solely for testing,
 * is an implementation of SurfaceDisplayController
 * which does a wireframe rendering of the various
 * grids it is given. Word information is ignored.
 *
 */
public class GridDisplay extends Panel
                         implements SurfaceDisplayController
{
    WireframePanel display3D=new WireframePanel();
    Vector surfaces=new Vector();

    public void init()
    {
        int sh=20;

        setLayout(new GridLayout(1,1));
        int w=size().width, h=size().height;

        add(display3D);
        display3D.reshape(0,2*sh,w,h-2*sh);
        display3D.setDistance(700);
        display3D.nextFrame();
    }

    public void start() {display3D.start();}
    public void stop() {display3D.stop();}

    synchronized public void clearSurfaces()
    {
        surfaces=new Vector();
        display3D.clear();
        display3D.nextFrame();
    }

    synchronized public void addSurface(WordSurface surface)
    {
        surfaces.addElement(surface);
        addGrid(surface.getGrid());
    }

    synchronized public void updateDisplay()
    {
        display3D.nextFrame();
    }

    public void setColor(Color color)
    {
        display3D.setColor(color);
    }

    public void addGrid(Point3D[][] q)
    {

        for (int i=0; i<q.length; i++)
        {
            for (int j=0; j<q[i].length; j++)
            {
                if (i<q.length-1)
                    display3D.addSegment(q[i][j], q[i+1][j]);
                if (j<q[i].length-1)
                    display3D.addColorSegment(q[i][j], q[i][j+1], i==0 ? Color.red : Color.gray);
            }
        }
    }
}