package apt.servlet;

import com.bewitched.servlet.*;
import java.io.*;

/**
 *
 * Holds static methods for describing server-dependent
 * file paths.
 *
 */
public class ApartmentPath extends SimpleServlet
{
    /**
     *
     * Resource file holding all properties.
     *
     */
    private static TextResource properties=
        new TextResource(new ApartmentPath().getClass(),
                         "ApartmentPath.properties");

    /**
     *
     * Print out information for web-based debugging.
     *
     */
    protected void print(PrintWriter out)
    {
        properties.printHTML(out);
        //out.println("File path for x/y: "+filePath("x/y"));
    }

    /**
     *
     * Return the index file with apartment summary info.
     *
     */
    public static String indexFile()
    {
        return filePath(properties.get("index file"));
    }

    /**
     *
     * Return the apartment info file for given apartment key.
     *
     */
    public static String apartmentFile(String key)
    {
        return filePath(properties.get("text directory")+key+".txt");
    }

    /**
     *
     * Return the vrml file for given apartment key.
     *
     */
    public static String vrmlFile(String key)
    {
        return filePath(properties.get("vrml directory")+key+".wrl");
    }
    
    /**
     * Return a full, machine-specific file path for
     * data for the apartment project.
     *
     * @param simplePath a String holding the virtual file path.
     * @return a String representing the true local file path.
     */
    public static String filePath(String simplePath)
    {
        return ServerEnvironment.filePath(properties.get("path")+simplePath);
    }
}