package apt.vrml;

import apt.plan3d.WordSurface;
import space.Point3D;
import java.io.*;

/**
 *
 * A class that implements the VRMLConverter interface should
 * use the writeToVRML() method to create a VRML world corresponding
 * to the array of WordSurface objects it's been given, and write
 * that VRML world to the Writer it's given.
 *
 */
public interface VRMLConverter
{
    /**
     *
     * Create a VRML world from the given information,
     * and write it to the specified Writer.
     * 
     * @param surfaces The "walls" of the memory palace.
     *
     * @param tour The points on the animated tour of the building.
     *             (This may be null for a while, but is important
     *              in the future.)
     *
     * @param out The Writer to write the world to.
     *
     */
    public void writeToVRML(RoomInfo[] info, 
                            int[] tour,
                            Writer out) 
                            throws IOException;
}
