package com.bewitched.servlet;

import java.io.*;

/**
This class makes it easy to deal with String-based file data.
It provides very simple read, write, and append methods
so you can store and retrieve String-based data
without having to deal with streams.
*/
public class TextFile
{
    public static final String CRLF=""+((char)13)+((char)10);
    private String path;
    private String errorMessage;

    /**
    Construct with a filepath.
    */
    public TextFile(String path)
    {
        this.path=path;
    }

    /**
    Write the result of data.toString() to the file.
    */
    synchronized public void write(Object data) throws IOException
    {
        BufferedWriter out=new BufferedWriter(new FileWriter(path));
        String s=data.toString();
        out.write(s,0,s.length());
        out.flush();
        out.close();
    }

    /**
    Append data.toString() to the file.
    */
    synchronized public void append(Object data) throws IOException
    {
        write(read().append(data));
    }

    /**
    Return a StringBuffer containing the contents of the file.
    */
    synchronized public StringBuffer read() throws IOException
    {
        BufferedReader in=new BufferedReader(new FileReader(path));
        String line=null;
        StringBuffer b=new StringBuffer();
        while (null != (line=in.readLine()))
        {
            b.append(line);
            b.append(CRLF);
        }
        in.close();
        return b;
    }

}
